// true - простое сравнение чисел
console.log(5 > 4);

// false - буква я имеет большее значение в системе Unicode
console.log("ананас" > "яблоко");

// true - сравнение строк, происходит посимвольно
console.log("2" > "12");

//  true - равны друг другу при нестрогом сравнении
console.log(undefined == null);

// false - строгое сравнение, объективно разные значения
console.log(undefined === null);

// false - null равно только null или undefined при нестрогом сравнении, 
// а второй операнд при переводе в число будет 0, лишние пробелы отбрасываются
console.log(null == "\n0\n");

// false - null будет сравниваться с 0
console.log(null === +"\n0\n");

// 10 - если строка - произойдёт конкатенация
console.log('"" + 1 + 0', "" + 1 + 0);

// -1 - из-за знака минус пустая строка примет значение 0 
// и произойдёт обычное математическое действие 0 - 1 + 0
console.log("" - 1 + 0);

// 1 - при переводе к числам выражение примет вид 1 + 0
console.log(true + false);

// 2 - знак деления "прикажет" второму операнду стать цифрой
console.log(6 / "3");

// 6 - выражение примет вид 2 * 3
console.log("2" * "3");

// 9px - сначала сложатся числа, после произойдёт конкатенация
console.log(4 + 5 + "px");

// $45 - первый символ строка, будет конкатенация на каждом шаге
console.log("$" + 4 + 5);

// 2 - знак из-за минуса строка "4" станет числом
console.log("4" - 2);

// NaN - строка 4px при переводе в число даст значение NotANumber (NaN)
console.log("4px" - 2);

// Infinity - бесконечность
console.log(7 / 0);

// "  -9  5" - конкатенация как в примерах выше
console.log("  -9  " + 5);

// -14 - перевод строки в число, лишние пробелы отбрасываются
console.log("  -9  " - 5);

// 1 - null при переводе в число вернёт 0
console.log(null + 1);

// NaN - undefuned при переводе в число вернёт NaN
console.log(undefined + 1);

// -2 - пробелы и переводы строк обрежутся, пустая строка вернёт 0, 0 - 2 = -2
console.log(" \t \n" - 2);